#ifndef HTTPGET_H
#define HTTPGET_H

#include <QObject>
#include <QPoint>
#include <QString>
#include <QBuffer>
#include <QHttp>
#include <QUrl>

class HttpGet : public QObject
{
    Q_OBJECT
private:
    QUrl myUrl;
    QHttp *myHttp;
    QBuffer *myBuffer;
    QString myFileName;
    int reqId;
    bool isAborted;
    int myResponseState;

public:
    HttpGet(QObject *parent = 0);
    virtual ~HttpGet();
    bool getFile(const QUrl& url, const QString& fileName);
    const QByteArray& getData() const { return myBuffer->data(); }
    void close();
    const QString& filename() { return myFileName; }
    int responseState() { return myResponseState; }
signals:
    void done(bool error);
    void finished();
private slots:
    void httpDone(int, bool);
    void changeState(int);
    void gotResponse(QHttpResponseHeader);
public slots:
    void abort();
};

#endif // HTTPGET_H
