#ifndef MARCHINGSQUARE_H
#define MARCHINGSQUARE_H

#include <QPoint>
#include <QList>

class MarchingSquare
{
private:
    int *mesh;
    int nx, ny;
    int step;
    int *mark;
    QPoint msVertex(int niveau, int ix0, int iy0, int ix1, int iy1);
    int msId(int niveau, int ix, int iy);
    const QList<QPoint> msStep(int niveau, int ix0, int iy0);
    int msOrient(int id, int prevDir);
    void msStart(int niveau, int &ix0, int &iy0, int& preDir);
    int getStartDir(int ix0, int iy0, int id);
    void reverse(QList<QPoint>& list);

public:
    MarchingSquare(int *pmesh, int pnx, int pny, int pstep);
    virtual ~MarchingSquare();
    const QList<QList<QPoint> > niveauLines(int niveau);
};

#endif // MARCHINGSQUARE_H
