#include <cmath>
#include <QtDebug>
#include "projection.h"

Projection::Projection()
{
}

QPoint lonLat2Tile(const QPointF& lonLat, int zoom) {
    double lat = lonLat.y()*M_PI/180.0;
    int n = 1<<zoom;
    int x = (int)floor((lonLat.x()+180.0)/360.0*n);
    int y = (int)floor((1.0-log(tan(lat)+1.0/cos(lat))/ M_PI) / 2.0 * n);
    return QPoint(x, y);
}

QPointF tile2LonLat(const QPoint& tile, int zoom) {
    qDebug()<<"tile2LonLat "<<tile<<" "<<zoom;
    int n = 1<<zoom;
    double x = tile.x()*360.0/n - 180.0;
    double y = M_PI-2.0*M_PI*tile.y()/n;
    y = 180.0/M_PI * atan(0.5*(exp(y)-exp(-y)));
    qDebug()<<"x: "<<x<<" y: "<<y;
    return QPointF(x, y);
}

QPointF lonLat2Merc(const QPointF& lonLat) {
    QPointF res;
    res.setX(lonLat.x()*128/180.0);
    res.setY(log(tan(M_PI/4+lonLat.y()*(M_PI/180)/2))*128/M_PI);
    return res;
}

QPointF merc2Tile(const QPoint& tile, const QPointF& merc, int zoom) {
    int z = 1<<zoom;
    QPointF p((merc.x()+128)*z, (128-merc.y())*z);
    //qDebug()<<"merc2Tile"<<p<<"z: "<<z<<" tile: "<<tile*256;
    return p-tile*256;
}
